package j3d_lib;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: Borland Software Corporation</p>
 * 3D Engine Programmer - Zabolotnov Vadim Alexandrovich aka Nick-85
 * System Programmer - ? aka Grafmoto
 * Tester - ? aka Hobbit19
 * @version 1.0
 */

// Imports
import java.io.IOException;

public class Texture {

  public byte[]  data; //       0xAARRGGBB
                       //          width = height,
                       //  width  height  , ,       ,    data    
                       //   byte[] data      int[] data,
                       // ..           Java Vertual Machine

  public boolean isForModel;

  // Constructors
  public Texture( byte[] data, boolean isForModel )
  {
    this.data       = data;
    this.isForModel = isForModel;
  }

  public Texture( java.lang.String name, boolean isForModel ) throws IOException
  { //    
    //    03.11.05 (21:05)

    this.isForModel = isForModel;
    javax.microedition.lcdui.Image  image;

    try{ image = javax.microedition.lcdui.Image.createImage( name ); }
    catch( java.io.IOException io){
      System.out.println( "Texture File: " + name +" is none exist" );
      data = null;
      return;
    };
    int image_size = image.getWidth() * image.getHeight();
    int[] data = new int[ image_size ];
    image.getRGB( data, 0, image.getWidth(), 0, 0, image.getWidth(), image.getHeight() );

    this.data = new byte[ image_size * 4 ];

    for( int i=0; i<image_size; i++ ){
      this.data[i*4]    =  (byte)(   data[i] & 0x000000FF          );
      this.data[i*4+1]  =  (byte)( ( data[i] & 0x0000FF00 ) >>> 2  );
      this.data[i*4+2]  =  (byte)( ( data[i] & 0x00FF0000 ) >>> 4  );
      this.data[i*4+3]  =  (byte)( ( data[i] & 0xFF000000 ) >>> 6  );
    }
  }
}